use super::{Datum, DatumList, DatumVisitor};

impl DatumList for () {
    fn accept(&self, _: &mut impl DatumVisitor) {}
}

impl<T: Datum> DatumList for T {
    fn accept(&self, visitor: &mut impl DatumVisitor) {
        visitor.visit(self);
    }
}

impl<T0: Datum> DatumList for (T0,) {
    fn accept(&self, visitor: &mut impl DatumVisitor) {
        visitor.visit(&self.0);
    }
}

impl<T0: Datum, T1: Datum> DatumList for (T0, T1) {
    fn accept(&self, visitor: &mut impl DatumVisitor) {
        visitor.visit(&self.0);
        visitor.visit(&self.1);
    }
}

impl<T0: Datum, T1: Datum, T2: Datum> DatumList for (T0, T1, T2) {
    fn accept(&self, visitor: &mut impl DatumVisitor) {
        visitor.visit(&self.0);
        visitor.visit(&self.1);
        visitor.visit(&self.2);
    }
}

impl<T0: Datum, T1: Datum, T2: Datum, T3: Datum> DatumList for (T0, T1, T2, T3) {
    fn accept(&self, visitor: &mut impl DatumVisitor) {
        visitor.visit(&self.0);
        visitor.visit(&self.1);
        visitor.visit(&self.2);
        visitor.visit(&self.3);
    }
}

impl<T0: Datum, T1: Datum, T2: Datum, T3: Datum, T4: Datum> DatumList for (T0, T1, T2, T3, T4) {
    fn accept(&self, visitor: &mut impl DatumVisitor) {
        visitor.visit(&self.0);
        visitor.visit(&self.1);
        visitor.visit(&self.2);
        visitor.visit(&self.3);
        visitor.visit(&self.4);
    }
}

impl<T0: Datum, T1: Datum, T2: Datum, T3: Datum, T4: Datum, T5: Datum> DatumList
    for (T0, T1, T2, T3, T4, T5)
{
    fn accept(&self, visitor: &mut impl DatumVisitor) {
        visitor.visit(&self.0);
        visitor.visit(&self.1);
        visitor.visit(&self.2);
        visitor.visit(&self.3);
        visitor.visit(&self.4);
        visitor.visit(&self.5);
    }
}
